/*
	logon.c - function to handle logging on to the geektalk server
	Copyright 2000, Jeff Hunt (heinz@skylab.org)
	License is GPL
*/

#include <fcntl.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>

#include "ctalk.h"
#include "functions.h"

int logon(char *username, char *hostname, int sockfd)
{
	int empty_queue, lines = 0, logged_on = NO;
	fd_set rset;
	struct timeval timeout;
	char outline[MAXLINE], recvline[MAXLINE]	;	

	empty_queue = YES;
	output(sockfd, "/signon\n");

	/* empty the queue so we can get messages about the username, and then sign on */
	while(logged_on == NO)
	{
		FD_ZERO(&rset);
		FD_SET(sockfd, &rset);
		timeout.tv_sec = 0;
		timeout.tv_usec = 5;

		if(lines == 1) empty_queue = NO;

		if(FD_ISSET(sockfd, &rset))
		{
			if(readline(sockfd, recvline, MAXLINE) == 0)
			{
				close(sockfd);
				fprintf(stderr, "Error: Server terminated prematurely.\n");
				exit(4);
			} 

			printf(" %s", recvline);

			if(empty_queue != YES)
			{
				if(strstr(recvline, "enter a username"))	/* it wants a user name */
				{
					sprintf(outline, "%s\n", username);
					output(sockfd, outline);
				} else 
				if(strstr(recvline, "Invalid username") || strstr(recvline, "is taken"))	/* We can't use the user name */
				{
					printf("\'%s\' is already taken or invalid. Try again, ese.\n", username);
					close(sockfd);
					exit(0);
				} else
				if(strstr(recvline, "enter a hostname"))
				{
					sprintf(outline, "%s\n", hostname);
					output(sockfd, outline);
				} else
				if(strstr(recvline, "Invalid hostname"))
				{
					printf("\'%s\' is an invalid hostname.\n", hostname);
					close(sockfd);
					exit(0);
				} else
				if(strstr(recvline, "signon|")) logged_on = YES;
			} else lines++;
		}			
	}

	return 1;
}
